summaryrefslogtreecommitdiffstats
path: root/ddns-client/libexec/ddns-client/list
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-09-09 19:31:22 +0000
committerDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-09-12 11:30:05 +0000
commitb34c796ab6be6e3eb6573842284011e00d5313dd (patch)
treed756aec41f550946367bcfb5b470d37aa85e80c9 /ddns-client/libexec/ddns-client/list
parentAdding ddns-client program. (diff)
downloadnetwork-tools-b34c796ab6be6e3eb6573842284011e00d5313dd.tar.xz
network-tools-b34c796ab6be6e3eb6573842284011e00d5313dd.zip
Adding ddns-client commands.
Signed-off-by: Daniel Baumann <daniel.baumann@open-infrastructure.net>
Diffstat (limited to 'ddns-client/libexec/ddns-client/list')
-rwxr-xr-xddns-client/libexec/ddns-client/list45
1 files changed, 45 insertions, 0 deletions
diff --git a/ddns-client/libexec/ddns-client/list b/ddns-client/libexec/ddns-client/list
new file mode 100755
index 0000000..664ddf5
--- /dev/null
+++ b/ddns-client/libexec/ddns-client/list
@@ -0,0 +1,45 @@
+#!/bin/sh
+
+# Copyright (C) 2014-2021 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+. /etc/network-tools/config/ddns-client.conf
+
+# alternatives handling for dig
+if command -v kdig > /dev/null 2>&1
+then
+ # knot-dnsutils
+ DIG="kdig +noadditional"
+elif command -v dig > /dev/null 2>&1
+then
+ # bind9-dnsutils
+ DIG="dig +noadditional"
+else
+ echo "'${HOOK}': need dig from bind9-dnsutils or knot-dnsutils" >&2
+ exit 1
+fi
+
+NAMESERVER="$(echo ${NAMESERVERS} | awk '{ print $1 }')"
+
+# Run
+for NAMESERVER in ${NAMESERVERS}
+do
+ # shellcheck disable=SC2086
+ ${DIG} -k "${TSIG_KEYFILE}" @"${NAMESERVER}" AXFR "${ZONE}"
+done | grep -E 'IN (A|AAAA|TXT) ' | sort -u